﻿Imports System.Collections.Generic
Imports System.Xml.Linq
Imports XMLSmartHelper.N4N.xml.helper

''' <summary>
''' Copyright © 2016 Nick4Name di Nicola Martella & F. s.a.s
'''     This file is part of XMLSmartHelperMule.
''' XMLSmartHelperMule Is free software: you can redistribute it And/Or modify
''' it under the terms Of the GNU Lesser General Public License As published by
''' the Free Software Foundation, either version 3 Of the License, Or
''' (at your option) any later version.
''' 
''' XMLSmartHelperMule Is distributed In the hope that it will be useful,
''' but WITHOUT ANY WARRANTY; without even the implied warranty Of
''' MERCHANTABILITY Or FITNESS FOR A PARTICULAR PURPOSE.  See the
''' GNU Lesser General Public License For more details.
''' 
''' You should have received a copy Of the GNU Lesser General Public License
''' along with XMLSmartHelperMule.  If Not, see <http://www.gnu.org/licenses/>.
''' 
''' Email Author: nick4name@gmail.com
''' </summary>
Public Class FMule

#Region " Variabili "

#End Region ' Variabili

#Region " Costanti "
   Private Const TEXT_VALUE_DELIMITER As String = Chr(34)
#End Region ' Costanti 

#Region " Costanti configurazione "

#End Region ' Costanti

#Region " Metodi "

#End Region ' Metodi

#Region " Funzioni "
   ''' <summary>
   ''' Seleziona la riga della textbox in cui è posizionato il cursore.
   ''' </summary>
   ''' <param name="txtbox"></param>
   ''' <remarks>
   ''' Utile nelle textbox multiline a fronte del double-click su una riga.
   ''' </remarks>
   ''' <history>
   ''' 	[MARTELLA]	04/04/2016	Created
   ''' </history>
   Private Sub selectLineInTextbox(txtbox As TextBox)
      Dim current_line As Integer = txtbox.GetLineFromCharIndex(txtbox.SelectionStart)
      Dim line_length As Integer = txtbox.Lines(current_line).Length

      txtbox.SelectionStart = txtbox.GetFirstCharIndexOfCurrentLine
      txtbox.SelectionLength = line_length
   End Sub

   Private Sub blinking()

      For j As Integer = 0 To 1
         pbxClipboard.Visible = True
         For i As Integer = 0 To 250
            pbxClipboard.Refresh()
         Next
         pbxClipboard.Visible = False
         For i As Integer = 0 To 1000
            pbxClipboard.Refresh()
         Next
      Next

   End Sub

   ''' <summary>
   ''' Seleziona il testo della textbox contenuto fra due delimitatori delim
   ''' </summary>
   ''' <param name="textbox"></param>
   ''' <param name="delim"></param>
   Private Sub selectBetweenDelimiters(textbox As TextBox, delim As String)
      Dim pSelSt As Integer = txtItem.SelectionStart
      Dim pSt As Integer = 0

      ' cerca eventuale spazio a sinistra dell'area selezionata
      For i As Integer = pSelSt To 0 Step -1
         If txtItem.Text.Substring(i, 1).Equals(TEXT_VALUE_DELIMITER) Or txtItem.Text.Substring(i, 1).Equals(vbTab) Then
            pSt = i + 1
            Exit For
         End If
      Next

      ' cerca eventuale spazio a destra dell'area selezionata
      Dim pEnd As Integer = txtItem.Text.IndexOf(TEXT_VALUE_DELIMITER, pSelSt)
      If pEnd = -1 Then pEnd = txtItem.Text.Length

      txtItem.SelectionStart = pSt
      txtItem.SelectionLength = pEnd - pSt
   End Sub

   ''' <summary>
   ''' Ritorna true o false a seconda che tutti i campi obbligatori siano o meno compilati.
   ''' </summary>
   ''' <returns>True se tutti i campi obbligatori sono stati compilati.</returns>
   Private Function checkForComplete() As Boolean
      Return (txtElem.Text.Trim.Length > 0)
   End Function

   Private Sub showXML()
      Dim file As String = txtFilename.Text.Trim
      Dim x As XDocument = New XDocument()

      Try
         If System.IO.File.Exists(file) Then
            x = XDocument.Load(file)
         End If
         txtResult.Text = x.ToString

      Catch ex As Exception
         MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

      End Try

   End Sub

   Private Function getAttributes() As List(Of KeyValuePair(Of String, String))
      Dim l As List(Of KeyValuePair(Of String, String)) = New List(Of KeyValuePair(Of String, String))
      Dim s As String = txtAttribs.Text + vbCrLf
      Dim rows As String() = s.Split(vbCrLf)

      For Each r As String In rows
         r = r.Trim
         If r.Trim.Length > 0 And r.IndexOf(" ") > -1 Then
            Dim vp As String() = r.Split(" ")
            Dim k As KeyValuePair(Of String, String) = New KeyValuePair(Of String, String)(vp(0), vp(1))
            l.Add(k)
         End If
      Next

      Return l

   End Function

   Private Sub btnShowXML_Click(sender As Object, e As EventArgs) Handles btnShowXML.Click
      showXML()
   End Sub

#End Region

#Region " XMLHelper "

   Private Sub btnCreateRoot_Click(sender As Object, e As EventArgs) Handles btnCreateRoot.Click
      txtElem.Text = txtElem.Text.Trim
      If txtElem.Text = "" Then
         MessageBox.Show("Insert element name")
         txtElem.Focus()
         Exit Sub
      End If

      Try
         Dim xml As XMLHelper = New XMLHelper(txtFilename.Text)
         Dim elid As ElID = xml.createRootElement(txtElem.Text)

         showXML()

      Catch ex As Exception
         MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

      End Try

   End Sub

   Private Sub btnCreateRootAttr_Click(sender As Object, e As EventArgs) Handles btnCreateRootAttr.Click
      txtElem.Text = txtElem.Text.Trim
      If txtElem.Text = "" Then
         MessageBox.Show("Insert element name")
         txtElem.Focus()
         Exit Sub
      End If

      txtAttribs.Text = txtAttribs.Text.Trim
      If txtAttribs.Text = "" Then
         MessageBox.Show("Insert attributes")
         txtAttribs.Focus()
         Exit Sub
      End If

      Dim attrs As List(Of KeyValuePair(Of String, String)) = getAttributes()

      Try
         Dim xml As XMLHelper = New XMLHelper(txtFilename.Text)
         Dim elid As ElID = xml.createRootElement(txtElem.Text, attrs)

         showXML()

      Catch ex As Exception
         MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

      End Try

   End Sub

   Private Sub btnCreateChildElement_Click(sender As Object, e As EventArgs) Handles btnCreateChildElem.Click
      txtElem.Text = txtElem.Text.Trim
      If txtElem.Text = "" Then
         MessageBox.Show("Insert element name")
         txtElem.Focus()
         Exit Sub
      End If

      txtElID.Text = txtElID.Text.Trim
      If txtElID.Text.Trim = "" Then
         MessageBox.Show("Insert parent ElID")
         txtElID.Focus()
         Exit Sub
      End If

      Try
         Dim xml As XMLHelper = New XMLHelper(txtFilename.Text)
         Dim elid As ElID = xml.createChildElement(txtElID.Text, txtElem.Text)
         If elid Is Nothing Then
            MessageBox.Show(String.Format("Parent element with ElID {0} not found.", txtElID.Text), "createChildElement", MessageBoxButtons.OK, MessageBoxIcon.Information)
         End If
         showXML()

      Catch ex As Exception
         MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

      End Try

   End Sub

   Private Sub btnCreateChildElemAttr_Click(sender As Object, e As EventArgs) Handles btnCreateChildElemAttr.Click
      txtElem.Text = txtElem.Text.Trim
      If txtElem.Text = "" Then
         MessageBox.Show("Insert element name")
         txtElem.Focus()
         Exit Sub
      End If

      txtElID.Text = txtElID.Text.Trim
      If txtElID.Text.Trim = "" Then
         MessageBox.Show("Insert parent ElID")
         txtElID.Focus()
         Exit Sub
      End If

      txtAttribs.Text = txtAttribs.Text.Trim
      If txtAttribs.Text = "" Then
         MessageBox.Show("Insert attributes")
         txtAttribs.Focus()
         Exit Sub
      End If

      Dim attrs As List(Of KeyValuePair(Of String, String)) = getAttributes()

      Try
         Dim xml As XMLHelper = New XMLHelper(txtFilename.Text)
         Dim elid As ElID = xml.createChildElement(txtElID.Text, txtElem.Text, attrs)
         If elid Is Nothing Then
            MessageBox.Show(String.Format("Parent element with ElID {0} not found.", txtElID.Text), "createChildElement", MessageBoxButtons.OK, MessageBoxIcon.Information)
         End If

         showXML()

      Catch ex As Exception
         MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

      End Try

   End Sub

   Private Sub btnSetValue_Click(sender As Object, e As EventArgs) Handles btnSetTextValue.Click
      txtElem.Text = txtElem.Text.Trim
      If txtElem.Text = "" Then
         MessageBox.Show("Insert value")
         txtElem.Focus()
         Exit Sub
      End If

      txtElID.Text = txtElID.Text.Trim
      If txtElID.Text.Trim = "" Then
         MessageBox.Show("Insert ElID")
         txtElID.Focus()
         Exit Sub
      End If

      Dim xml As XMLHelper = New XMLHelper(txtFilename.Text)
      xml.setTextValue(txtElID.Text, txtElem.Text)

      showXML()
   End Sub

   Private Sub btnSetValueAttr_Click(sender As Object, e As EventArgs) Handles btnSetValueAttr.Click
      If txtAttribs.Text = "" Then
         MessageBox.Show("Insert attribute + value")
         txtAttribs.Focus()
         Exit Sub
      End If

      txtElID.Text = txtElID.Text.Trim
      If txtElID.Text.Trim = "" Then
         MessageBox.Show("Insert ElID")
         txtElID.Focus()
         Exit Sub
      End If

      Dim attrs As List(Of KeyValuePair(Of String, String)) = getAttributes()
      If attrs.Count = 0 Then
         MessageBox.Show("Insert attribute + value in the 'attribute space value' format.")
         txtAttribs.Focus()
         Exit Sub
      End If

      Dim xml As XMLHelper = New XMLHelper(txtFilename.Text)
      xml.setAttributeValue(txtElID.Text, attrs(0).Value, attrs(0).Key)

      showXML()

   End Sub

   Private Sub btnDelete_Click(sender As Object, e As EventArgs) Handles btnDelete.Click

      txtElID.Text = txtElID.Text.Trim
      If txtElID.Text.Trim = "" Then
         MessageBox.Show("Insert ElID")
         txtElID.Focus()
         Exit Sub
      End If

      Dim xml As XMLHelper = New XMLHelper(txtFilename.Text)

      Try
         xml.deleteElID(txtElID.Text)

         showXML()

      Catch ex As Exception
         MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

      End Try

   End Sub

   Private Sub btnGetElem_Click(sender As Object, e As EventArgs) Handles btnGetElem.Click

      txtElID.Text = txtElID.Text.Trim
      If txtElID.Text.Trim = "" Then
         MessageBox.Show("Insert ElID")
         txtElID.Focus()
         Exit Sub
      End If

      Dim xml As XMLHelper = New XMLHelper(txtFilename.Text)

      Try
         Dim xElem As XElement = xml.getElement(txtElID.Text)

         txtResult.Text = ""
         txtResult.Text = String.Format("{0} :: {1}{2}", txtElID.Text, vbCrLf, xElem.ToString)

      Catch ex As Exception
         MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

      End Try

   End Sub

   Private Sub btnGetElemName_Click(sender As Object, e As EventArgs) Handles btnGetElemName.Click

      txtElID.Text = txtElID.Text.Trim
      If txtElID.Text.Trim = "" Then
         MessageBox.Show("Insert ElID")
         txtElID.Focus()
         Exit Sub
      End If

      Dim xml As XMLHelper = New XMLHelper(txtFilename.Text)

      Try
         Dim elid As ElID = xml.getElementName(txtElID.Text)

         txtResult.Text = ""
         txtResult.Text = String.Format("{0} :: {1}", elid.ElID, elid.name)

      Catch ex As Exception
         MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

      End Try

   End Sub

   Private Sub btnGetAttribVal_Click(sender As Object, e As EventArgs) Handles btnGetAttribVal.Click
      txtElem.Text = txtElem.Text.Trim
      If txtElem.Text = "" Then
         MessageBox.Show("Insert attribute name")
         txtElem.Focus()
         Exit Sub
      End If

      txtElID.Text = txtElID.Text.Trim
      If txtElID.Text.Trim = "" Then
         MessageBox.Show("Insert ElID")
         txtElID.Focus()
         Exit Sub
      End If

      Dim xml As XMLHelper = New XMLHelper(txtFilename.Text)

      Try
         Dim elem As String = xml.getAttributeValue(txtElID.Text, txtElem.Text)
         If elem Is Nothing Then
            MessageBox.Show(String.Format("The attribute {0} doesn't exist.", txtElem.Text), "getAttributeValue", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
         End If

         txtResult.Text = ""
         txtResult.Text = String.Format("{0} :: {1} :: {2}", txtElID.Text, txtElem.Text, elem)

      Catch ex As Exception
         MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

      End Try

   End Sub

   Private Sub btnDeleteAttrib_Click(sender As Object, e As EventArgs) Handles btnDeleteAttrib.Click
      txtElem.Text = txtElem.Text.Trim
      If txtElem.Text = "" Then
         MessageBox.Show("Insert attribute name")
         txtElem.Focus()
         Exit Sub
      End If

      txtElID.Text = txtElID.Text.Trim
      If txtElID.Text.Trim = "" Then
         MessageBox.Show("Insert ElID")
         txtElID.Focus()
         Exit Sub
      End If

      Dim xml As XMLHelper = New XMLHelper(txtFilename.Text)
      xml.deleteAttribute(txtElID.Text, txtElem.Text)

      showXML()

   End Sub

   Private Sub btnGetElID_Click(sender As Object, e As EventArgs) Handles btnGetElID.Click

      txtElem.Text = txtElem.Text.Trim
      If txtElem.Text.Trim = "" Then
         MessageBox.Show("Insert element name")
         txtElem.Focus()
         Exit Sub
      End If

      Dim xml As XMLHelper = New XMLHelper(txtFilename.Text)

      Try
         Dim matches As List(Of KeyValuePair(Of String, ElID)) = xml.getElID(txtElem.Text)

         txtResult.Text = ""
         For Each m As KeyValuePair(Of String, ElID) In matches
            txtResult.Text += String.Format("{0} :: {1}", m.Value.name, m.Key) + vbCrLf
         Next

      Catch ex As Exception
         MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

      End Try
   End Sub

   Private Sub btnGetElIDSrc_Click(sender As Object, e As EventArgs) Handles btnGetElIDSrc.Click

      txtElem.Text = txtElem.Text.Trim
      If txtElem.Text.Trim = "" Then
         MessageBox.Show("Insert the desired element name")
         txtElem.Focus()
         Exit Sub
      End If

      txtElID.Text = txtElID.Text.Trim
      If txtElID.Text.Trim = "" Then
         MessageBox.Show("Insert root ElID contents desired element")
         txtElID.Focus()
         Exit Sub
      End If

      Dim xml As XMLHelper = New XMLHelper(txtFilename.Text)

      Try
         Dim xElem As XElement = xml.getElement(txtElID.Text)
         Dim matches As List(Of KeyValuePair(Of String, ElID)) = xml.getElID(txtElem.Text, xElem)

         txtResult.Text = ""
         If Not IsNothing(matches) Then
            For Each m As KeyValuePair(Of String, ElID) In matches
               txtResult.Text += String.Format("{0} :: {1}", m.Value.name, m.Key) + vbCrLf
            Next
         Else
            MessageBox.Show(String.Format("Element {0} not found in the source or unique element in the source.", txtElem.Text),
                            "getElID by source", MessageBoxButtons.OK, MessageBoxIcon.Information)
         End If

      Catch ex As Exception
         MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

      End Try

   End Sub

   Private Sub btnGetElIDAttr_Click(sender As Object, e As EventArgs) Handles btnGetElIDAttr.Click

      txtElem.Text = txtElem.Text.Trim
      If txtElem.Text.Trim = "" Then
         MessageBox.Show("Insert element name")
         txtElem.Focus()
         Exit Sub
      End If

      If txtAttribs.Text = "" Then
         MessageBox.Show("Insert attribute + value")
         txtAttribs.Focus()
         Exit Sub
      End If

      Dim attrs As List(Of KeyValuePair(Of String, String)) = getAttributes()

      Dim xml As XMLHelper = New XMLHelper(txtFilename.Text)

      Try
         Dim matches As List(Of KeyValuePair(Of String, ElID)) = xml.getElID(txtElem.Text, attrs)

         txtResult.Text = ""
         For Each m As KeyValuePair(Of String, ElID) In matches
            txtResult.Text += String.Format("{0} :: {1}", m.Value.name, m.Key) + vbCrLf
         Next

      Catch ex As Exception
         MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

      End Try

   End Sub

   Private Sub btnGetElIDSrcAttr_Click(sender As Object, e As EventArgs) Handles btnGetElIDSrcAttr.Click

      txtElem.Text = txtElem.Text.Trim
      If txtElem.Text.Trim = "" Then
         MessageBox.Show("Inserisci desired element name")
         txtElem.Focus()
         Exit Sub
      End If

      If txtAttribs.Text = "" Then
         MessageBox.Show("Insert attribute + value for the desired element")
         txtAttribs.Focus()
         Exit Sub
      End If

      Dim attrs As List(Of KeyValuePair(Of String, String)) = getAttributes()


      txtElID.Text = txtElID.Text.Trim
      If txtElID.Text.Trim = "" Then
         MessageBox.Show("Insert root ElID containing the desired element")
         txtElID.Focus()
         Exit Sub
      End If

      Dim xml As XMLHelper = New XMLHelper(txtFilename.Text)

      Try
         Dim xElem As XElement = xml.getElement(txtElID.Text)
         Dim matches As List(Of KeyValuePair(Of String, ElID)) = xml.getElID(txtElem.Text, attrs, xElem)

         txtResult.Text = ""
         If Not IsNothing(matches) Then
            For Each m As KeyValuePair(Of String, ElID) In matches
               txtResult.Text += String.Format("{0} :: {1}", m.Value.name, m.Key) + vbCrLf
            Next
         Else
            MessageBox.Show(String.Format("Element {0} not found in the source or unique element in the source.", txtElem.Text),
                            "getElID by source", MessageBoxButtons.OK, MessageBoxIcon.Information)
         End If

      Catch ex As Exception
         MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

      End Try
   End Sub

#End Region ' XMLHelper

#Region " Front-end "

   Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)

   End Sub

   Protected Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
      txtResult.Text = ""
      txtItem.Text = ""
   End Sub

   Private Sub txtItem_DoubleClick(sender As Object, e As EventArgs) Handles txtItem.DoubleClick
      If txtItem.Text.Length = 0 Then Exit Sub

      selectBetweenDelimiters(txtItem, TEXT_VALUE_DELIMITER)
   End Sub

   Private Sub txtElId_Click(sender As Object, e As EventArgs) Handles txtElID.Click
      txtElID.SelectionStart = 0
      txtElID.SelectionLength = txtElID.Text.Length
   End Sub

   Private Sub txtid2_Click(sender As Object, e As EventArgs) Handles txtAttribs.Click
      txtAttribs.SelectionStart = 0
      txtAttribs.SelectionLength = txtAttribs.Text.Length
   End Sub

   Private Sub txtDelXML_Click(sender As Object, e As EventArgs) Handles txtDelXML.Click

      If MessageBox.Show("Are you sure?", "DB deletion", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question) = DialogResult.Yes Then
         If System.IO.File.Exists(txtFilename.Text) Then
            System.IO.File.Delete(txtFilename.Text)
            MessageBox.Show("DB file deleted.", "Deletion", MessageBoxButtons.OK, MessageBoxIcon.Information)
         End If
      End If

   End Sub

   Private Sub txtResult_DoubleClick(sender As Object, e As EventArgs) Handles txtResult.DoubleClick
      selectLineInTextbox(txtResult)

      txtItem.Text = txtResult.SelectedText

   End Sub

   Private Sub txtItem_Click(sender As Object, e As EventArgs) Handles txtItem.Click
      If txtItem.Text.Length = 0 Then Return

      selectBetweenDelimiters(txtItem, TEXT_VALUE_DELIMITER)
      Clipboard.SetText(txtItem.SelectedText)

      blinking()

   End Sub

#End Region ' Front-end

End Class
